class RailheadPreheatController < ActionController::Metal
  include AbstractController::Rendering
  include AbstractController::Helpers
  include ActionController::Caching
  include ActionView::Layouts

  def initialize(*args)
    super()
    self.class.send :include, Rails.application.routes.url_helpers
    self.class.send :helper, ApplicationHelper
    lookup_context.view_paths = ApplicationController.view_paths
    config.cache_store = ActionController::Base.cache_store
  end
end


module RailheadPreheat

  def preheat(item = self)
    item.reload if item.respond_to?(:reload)
    RailheadPreheatController.new.render_to_string(item)
  end
end


ActiveRecord::Base.send :include, RailheadPreheat
